'-----------------------------------------------------------------
' CCTools IC-Bus-Routinen fr Open-Micro/Open-Mini
' zum PCF-LCD-Interface und I2C-Terminal
' CCTools 2005 (http://cctools.hs-control.de)
'-----------------------------------------------------------------
' Die Routinen bauen auf den IC-Bus-ASM-Treiber (om_i2c.bas)
' von Dietmar Harlos auf. Dieser kann von C-Control-Intern geladen
' werden (http://ccintern.dharlos.de)
' Das Bsp. ist in OC-Basic(von Dietmar Harlos) geschrieben.
'-----------------------------------------------------------------
' Die hufigsten IC-Bus-Adressen:
' &h20 - &h2E    MAX7311 16Bit Portexpander
' &h30 - &h3E    MAX7311 16Bit Portexpander
' &h40 - &h4E    MAX7311 16Bit Portexpander
' &h40 - &h4E    PCF8574 Portexpander
' &h50 - &h5E    MAX7311 16Bit Portexpander
' &h50 - &h5E    MAX520 4ch. 8Bit DA-Wandler
' &h68 - &h6E    MAX4572 Analog-Schalter (write only)
' &h70 - &h7E    PCF8574A Portexpander
' &h90 - &h9E    PCF8591 4ch. 8Bit AD-Wandler
' &h90 - &h9E    DS1631 12Bit Temperatursensor
' &hA0 - &hA2    PCF8583 Uhrenbaustein
' &hA0 - &hA6    serielle EEProms 24C128 - 24C512
' &hA0 - &hAE    serielle EEProms 24C01 - 24C64
' &hA0 - &hAE    MAX7311 16Bit Portexpander
' &hB0 - &hBE    MAX7311 16Bit Portexpander
' &hC0 - &hCE    MAX7311 16Bit Portexpander
' &hD0 - &hDE    MAX7311 16Bit Portexpander
'-----------------------------------------------------------------
' Portbelegung des LCDs am PCFLCD-Interface und I2C-Terminal:
' PCF8574   LCD
'  P.0       RS  (Register Select)
'  P.1       R/W (Read/Write)
'  P.2       En  (Enable)
'  P.3       LCD-Beleuchtung
'  P.4       D4  (Datenleitung des LCDs, 4Bit-Mode)
'  P.5       D5  (Datenleitung des LCDs, 4Bit-Mode)
'  P.6       D6  (Datenleitung des LCDs, 4Bit-Mode)
'  P.7       D7  (Datenleitung des LCDs, 4Bit-Mode)
'-----------------------------------------------------------------


define SCL PORT[5] ' Pull-Up mit je 10k empfohlen,
define SDA PORT[6] ' wenn die Busleitungen etwas lnger gezogen werden (>1m)


define i byte[1] 'temporres Byte
define x byte[2] 'temporres Byte
define j byte[3] 'temporres Byte (nur fr Printfunktion)

'ASCII
Define A_ &H41 : Define B_ &H42 : Define C_ &H43 : Define D_ &H44 : Define E_ &H45
Define F_ &H46 : Define G_ &H47 : Define H_ &H48 : Define I_ &H49 : Define J_ &H4A
Define K_ &H4B : Define L_ &H4C : Define M_ &H4D : Define N_ &H4E : Define O_ &H4F
Define P_ &H50 : Define Q_ &H51 : Define R_ &H52 : Define S_ &H53 : Define T_ &H54
Define U_ &H55 : Define V_ &H56 : Define W_ &H57 : Define X_ &H58 : Define Y_ &H59 : Define Z_ &H5A
Define ak &H61 : Define bk &H62 : Define ck &H63 : Define dk &H64 : Define ek &H65
Define fk &H66 : Define gk &H67 : Define hk &H68 : Define ik &H69 : Define jk &H6A
Define kk &H6B : Define lk &H6C : Define mk &H6D : Define nk &H6E : Define ok &H6F
Define pk &H70 : Define qk &H71 : Define rk &H72 : Define sk &H73 : Define tk &H74
Define uk &H75 : Define vk &H76 : Define wk &H77 : Define xk &H78 : Define yk &H79 : Define zk &H7A
Define SPACE &H20 : Define MINUS &H2D : Define GLEICH &H3D : Define DPP &H3A
Define Dot &H2E
Define Line1 &H80 : Define Line2 &HC0 : Define Line3 &H94 : Define Line4 &HD4 'Fr 4x20 LCD
'Define Line1 &H80 : Define Line2 &HC0 : Define Line3 &H90 : Define Line4 &HD0 'Fr 4x16 LCD


define PCFLCD &h40 'PCFLCD an PCF8574 ohne A an 0.0.0
                   ' Kann auch als Variable definiert werden,
                   ' um zwischen mehreren Interfaces umzuschalten.


gosub i2c_init ' "Initialisierung" des IC-Busses
pause 1

'Programmbeginn

gosub PCFLCD_init

'Ausgabe von einzelnen Zeichen
 PCFLCD_Put T_
 PCFLCD_Put ek
 PCFLCD_Put sk
 PCFLCD_Put tk

 PCFLCD_CMD Line2 ' zu Zeile 2 des LCDs springen
 PCFLCD_Put C_
 PCFLCD_Put C_
 PCFLCD_Put T_
 PCFLCD_Put ok
 PCFLCD_Put ok
 PCFLCD_Put lk
 PCFLCD_Put sk
 PCFLCD_Put SPACE
 PCFLCD_Put MINUS
 PCFLCD_Put SPACE
 PCFLCD_Put P_
 PCFLCD_Put C_
 PCFLCD_Put F_
 PCFLCD_Put L_
 PCFLCD_Put C_
 PCFLCD_Put D_

 pause 40
 PCFLCD_SetLight false 'Beleuchtung ausschalten
 pause 20
 PCFLCD_SetLight true 'Beleuchtung einschalten
 gosub PCFLCD_Clear

'Ausgabe von Festtexten mit Hilfe von Tabellen
 PCFLCD_Print 1 'Tabellenoffset
 PCFLCD_CMD Line2
 PCFLCD_Print 19 'Tabellenoffset

'Ausgabe des aktuellen Sekunden-Werts an Zeile 2 ab Spalte 12
 #loop
  PCFLCD_CMD Line2+12
  PCFLCD_Zahl second
  pause 10
 goto loop

end

'---------------------------------------
' Trick, um die Table-Funktion fr Festtexte zu "mibrauchen"
' max. 256 Byte pro Tabelle
' Achtung ! Experimentel !
table LCDtext
tabend
print "CCTools - PCFLCD"; 'Index 1 bis 16 Text
                          'Index 0 = print-Token
                          'Index 17 = ASCII 0 fr "Text-Ende"
print "28.09.2005";       'Index 19 bis 28 = Text
                          'Index 18 = print-Token
                          'Index 29 = ASCII 0 fr "Text-Ende"


'---------------------------------------
' PCF-LCD-Routinen (fr PCF-LCD-Interface & I2C-Terminal
'---------------------------------------
#PCFLCD_SetLight
 pop i
 i2c_start
 i2c_write PCFLCD
 i2c_write ((i<>0) and &h08)
 i2c_stop
return

#PCFLCD_init 'Initialisieren des Displays
 i2c_start
 i2c_write (PCFLCD OR 1)
 i=i2c_read(False) AND &h08
 i2c_stop
 i2c_start
 i2c_write PCFLCD
 'Function Set 8 Bit
 i2c_write &h30 or i
 i2c_write &h30 or i
 i2c_write &h34 or i
 i2c_write &h30 or i
 pause 1
 i2c_write &h34 or i
 i2c_write &h30 or i
 i2c_write &h34 or i
 i2c_write &h30 or i

 ' Function Set 4 Bit
 i2c_write &h24 or i
 i2c_write &h20 or i
 pause 1
 i2c_stop
 PCFLCD_CMD &h28 'Function Set, 2 Zeilen, 5x7 Punkte
 PCFLCD_CMD &h0C 'Cursor Off, display On
 PCFLCD_CMD &h06 'Entry-Mode; inkrement, Cursor-shift

#PCFLCD_Clear 'Lschen des Displayinhalts
 PCFLCD_CMD &h01
 pause 1
return

#PCFLCD_CMD ' Kommandobyte senden
 pop x
 i2c_start
 i2c_write PCFLCD OR 1
 i=i2c_read(False) AND &h08
 i2c_stop
 i2c_start
 i2c_write PCFLCD
 i2c_write ((x and &hF0) or &h4 or i)
 i2c_write ((x and &hF0) or i)
 i2c_write ((x shl 4) or &h4 or i)
 i2c_write ((x shl 4) or i)
 i2c_stop
return

#PCFLCD_PUT 'Zeichen senden
 pop x
 i2c_start
 i2c_write PCFLCD OR 1
 i=i2c_read(False) AND &h08
 i2c_stop
 i2c_start
 i2c_write PCFLCD
 gosub PCFLCD_SubPut
 i2c_stop
return

#PCFLCD_Print ' Zeichenfolge ausgeben.
 pop j
 i2c_start
 i2c_write PCFLCD OR 1
 i=i2c_read(False) AND &h08
 i2c_stop
 i2c_start
 i2c_write PCFLCD
 looktab LCDtext,j,x
 while x
  gosub PCFLCD_SubPut
  j=j+1
  looktab LCDtext,j,x
 wend
 i2c_stop
return

#PCFLCD_SubPut
 i2c_write ((x and &hF0) or &h5 or i)
 i2c_write ((x and &hF0) or &h1 or i)
 i2c_write ((x shl 4) or &h5 or i)
 i2c_write ((x shl 4) or &h1 or i)
return

#PCFLCD_Zahl1 '1 stellige Zahl ausgeben
 pop j
 gosub PCFLCD_Start
 goto PCFLCD_SubZahl1
#PCFLCD_Zahl2 ' 2 stellige Zahl ausgeben
 pop j
 gosub PCFLCD_Start
 goto PCFLCD_SubZahl2
#PCFLCD_Zahl
 pop j
 gosub PCFLCD_Start
 if j>99 then x=(j/100)+&h30 else x=SPACE
 gosub PCFLCD_SubPut
#PCFLCD_SubZahl2 ' 2 stellige Zahl ausgeben
 if j> 9 then x=((j/10) mod 10)+&h30 else x=SPACE
 gosub PCFLCD_SubPut
#PCFLCD_SubZahl1 '1 stellige Zahl ausgeben
 x=(j mod 10)+&h30
 gosub PCFLCD_SubPut
 i2c_stop
return

#PCFLCD_Start
 i2c_start
 i2c_write PCFLCD OR 1
 i=i2c_read(False) AND &h08
 i2c_stop
 i2c_start
 i2c_write PCFLCD
return


'---------------------------------------
' Einbinden der IC-Bus-Routinen
'---------------------------------------
include "om_i2c.bas"

